.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/entity_manager.h.s"
.include "sys/render_system.h.s"
.include "sys/physics_system.h.s"
.include "sys/collision_system.h.s"
.include "sys/generator_system.h.s"
.include "man/man_game.h.s"
.include "man/man_levels.h.s"
;_x, _y, _w, _h, _vx, _vy, _color, _prevX, _prevY, _state
DefineEntity player, 20, 150, 7, 12, 0, 176, _nave_sp, 0, 0,   #entity_player



jugarDeNuevo: .asciz "QUIERES JUGAR OTRA VEZ? PULSA Q."

jugarOtraVez::
      call clearScreen
      call print_jugar_OtraVez
      _wait_to_start_otra_vez:
      call cpct_waitVSYNC_asm
      call wait_forInput
      cp #0
      jr z, _wait_to_start
      jr _continue

 _continue_otra_vez:
      call clearScreen
      ;Iniciamos las entidades y el sistema de render
      
      call game_init


gameOver::

      call clearScreen
      call print_GameOver
      _wait_to_start:
      call cpct_waitVSYNC_asm
      call wait_forInput
      cp #0
      jr z, _wait_to_start
      jr _continue

 _continue:
      call clearScreen
      ;Iniciamos las entidades y el sistema de render
      ld b, #1
      call set_current_level_B
      call game_init

game_next_level::
      call entity_man_reset_entities

      call entity_man_getNaveArray_IX
      ld    hl, #player
      call  entity_man_create
      call  entity_man_setNaveArray_IX

      call clearScreen

      call entity_man_init
      call render_sys_init
      call render_Draw

   ;NOTAS:
   ;; La nave espacial siempre tendra que estar la primera en el array de entidades
   ;; La bala siempre tendra que estar la segunda en el array de entidades

   ;Cargamos las entidades que veamos convenientes 
   ret

game_init::
      call man_init_enemies_left
      call entity_man_reset_entities

      call entity_man_getNaveArray_IX
      ld    hl, #player
      call  entity_man_create
      call  entity_man_setNaveArray_IX

      call clearScreen

      call entity_man_init
      call render_sys_init
      call render_Draw

   ;NOTAS:
   ;; La nave espacial siempre tendra que estar la primera en el array de entidades
   ;; La bala siempre tendra que estar la segunda en el array de entidades

gameStart::
      call clearScreen
      call render_Draw
      ;;call print_Title

wait_forInput::
      call cpct_scanKeyboard_f_asm
      ld hl , #Key_Q
      call cpct_isKeyPressed_asm
      jr nz, _pressed
      jr z, _notPressed

_pressed:
      ld a, #1
      jr _end_if
_notPressed:
      ld a, #0
_end_if:
      ret

clearScreen::
   ld hl, #0xC000
   ld de, #0xC001
   ld bc, #0x4000
   ld (hl), #0
   ldir
   ret

print_Title::
call clearScreen
   ld   	 de, #0xC000  			; \
        ld    	 b, #0				; |	
        ld    	 c, #0				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_titulo_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm

        ld   	 de, #0xC000  			; \
        ld    	 b, #0				; |	
        ld    	 c, #40				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_titulo2_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ld   	 de, #0xC000  			; \
        ld    	 b, #80				; |	
        ld    	 c, #40				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_titulo4_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ld   	 de, #0xC000  			; \
        ld    	 b, #80				; |	
        ld    	 c, #0				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_titulo3_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ret

print_GameOver::
      call reset_recuento_oleadas_nv1
      call reset_recuento_oleadas_nv2

      call reset_recuento_oleadas_nv3
      call reset_recuento_oleadas_nv4

            ld   	 de, #0xC000  			; \
        ld    	 b, #50				; |	
        ld    	 c, #25				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_gameover_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm
        ret


print_jugar_OtraVez::
   ld   	 de, #0xC000  			; \
        ld    	 b, #50				; |	
        ld    	 c, #25				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /


        ex de, hl
        ;ld hl, #_nave_sp
        ld hl, #_titulo4_sp
        ld b, #80 ;alto
        ld c, #40;ancho


        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
        ;(2B DE) memory	Destination video memory pointer
        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
        ;(1B B ) height	Sprite Height in bytes (>0)        

        call cpct_drawSprite_asm 
   ret

