.include "cpctelera.h.s"
.include "man/entity_manager.h.s"
.include "render_system.h.s"
.include "collision_system.h.s"
.include "../cpct_functions.h.s"
.include "man/man_game.h.s"
.include "man/man_levels.h.s"
;.include "man/man_game.h.s"
aux :: .dw 0x00


;;Descripcion:
; metodo que comprueba las colisiones entre
; el array de nave y balas con el array de enemigos
;;explicacion::
;; for(i = num_enemigos; i>=0; i--){ --> loop_1
;;      for (j= num_naveyBalas; j>=0; j--) --> loop_2
;; 


;ARRAY DE NAVE Y BALAS EN IX
;ARRAY DE ENEMIGOS EN IY
sys_collision_check::
    ld   (aux), bc
    call entity_man_getEnemyArray_IX
    call entity_man_getNumEntities_A; obtenemos en a el numero de enemigos
    
    
    sub #0      ; Restamos 0, si da 0 es porque no hay enemigos 
    jr  z, final ; por tanto no comprobamos colisiones

    ld__d_ixh;\
    ld__e_ixl;|  IY = IX NOS GUARDAMOS EN IY EL ARRAY DE ENEMIGOS
    ld__iyh_d;|
    ld__iyl_e;/

    ld h, a ; --> h = i bucle externo; d almacena el numero total de enemigos
    
    loop_1:
        ld de, #entity_size 

        call    entity_man_getNaveArray_IX     ;NOS GUARDAMOS EN IX EL ARRAY DE NAVE Y BALAS
        call    entity_man_getNumEntities_A    ; obtenemos en a el numero de nave y balas
        ld      l, a                           ; --> l = j bucle interno; d almacena el numero total de nave y balas
        loop_2:
            ;COLISIONES EJE X
            ld  a, e_x(ix)
            add e_w(ix)
            sub e_x(iy)
            jr  c, no_destruir_player_ni_enemigo

            ld  a, e_x(iy)
            add e_w(iy)
            sub e_x(ix)
            jr  c, no_destruir_player_ni_enemigo

            ;COLISIONES EJE Y
            ld  a, e_y(ix)
            add e_h(ix)
            sub e_y(iy)
            jr  c, no_destruir_player_ni_enemigo

            ld  a, e_y(iy)
            add e_h(iy)
            sub e_y(ix)
            jr  c, no_destruir_player_ni_enemigo

            colision:
                ld  a, e_state(ix)          ; 
                and #entity_player          ;Si la entidad que ha colisionado es el player destruimos el player  
                jr  z, no_destruir_player   ;el player no puede colisionar con ninguna otra entidad

            destruir_player:
                ;AQUI VA EL GAMEOVER
                call gameOver
                ;call entity_man_reset_lifes
                jp      final
            
            no_destruir_player:
                ld  a, e_state(ix)                   
                and #entity_bullet                      
                jr  z, no_destruir_player_ni_enemigo                      
            
            destruir_bala_y_enemigo: ; como lo anterior era una bala destruimos las dos cosas: la bala y el enemigo
                call    entity_man_set4destroy
                call    entity_man_set4destroy_IY
                call    man_decrease_enemies_left
                jp      final

            no_destruir_player_ni_enemigo: ;algo ha colisionado pero no ha sido ni la nave con nada ni la bala con nada asi que ignoramos
                add ix, de
                dec l
                jr  z, vuelve_bucle1 ; se han acabado las entidades del bucle interno, volvemos al externo
                jr  nz, loop_2       ; no se han acabado las entidades del interno, seguimos
            
            vuelve_bucle1:
                add iy, de
                dec h
                jr  z, final ; hemos terminado con todas las entidades del bucle externo
                jr  nz, loop_1
            final:
                ld bc, (aux)
                ret
          

                
            


                

                
             
             

    ret
           