.include "cpctelera.h.s"
.include "generator_system.h.s"
.include "man/entity_manager.h.s"
.include "man/waves.h.s"

;_x, _y, _w, _h _vx, _vy, _color, _prevX, _prevY, _state
DefineEntity star, 79, 1, 1, 2, -1, 0, _estrella_sp, 0, 0,    #entity_star

level_1: .db 0
level_2: .db 0
level_3: .db 0
level_4: .db 0

recuento_oleadas_nv1: .db #0x0F
recuento_oleadas_nv2: .db #0x0F
recuento_oleadas_nv3: .db #0x0F
recuento_oleadas_nv4: .db #0x0F

reset_recuento_oleadas_nv1::
	ld a, #0x0F
	ld (recuento_oleadas_nv1), a
	ret
reset_recuento_oleadas_nv2::
	ld a, #0x0F
	ld (recuento_oleadas_nv2), a
	ret
reset_recuento_oleadas_nv3::
	ld a, #0x16
	ld (recuento_oleadas_nv3), a
	ret
reset_recuento_oleadas_nv4::
	ld a, #0x1E
	ld (recuento_oleadas_nv4), a
	ret

current_level: .db 1


get_current_level_A::
	ld a, (current_level)
	ret

;Recibe el nivel actual en B
set_current_level_B::
	ld a, b
	ld (current_level), a
	ret

barrera_1_value: .db #0x05
barrera_2_value: .db #0x05
barrera_3_value: .db #0x04

init_barrera_1_value:
	ld a, #0x0A
	ld (barrera_1_value), a
	ret

init_barrera_2_value:
	ld a, #0xB
	ld (barrera_2_value), a
	ret

init_barrera_3_value:
	ld a, #0xB
	ld (barrera_2_value), a
	ret



;--------------------------------------------------------------
;	FUNCIONES 
;--------------------------------------------------------------

; Funcion para generar una nueva estrella siempre que sea posible 
generator_sys_update::
   	call entity_man_getStarsArray_IX
	call entity_man_getFreeSpace_A
	ret	 z
	call generator_sys_NewElement
	ret

generator_sys_NewElement:

	ld    hl, #star
   call  entity_man_create
   call  entity_man_setStarsArray_IX
   call  entity_man_getLastEntity_IX

   	generate:
   		call cpct_getRandom_xsp40_u8_asm
      	cp    #174
      	jr    nc, generate
      	ld    e_y(ix), a

      	call cpct_getRandom_xsp40_u8_asm
      	and   #0x03
      	add   #1
      	neg
      	ld    e_vx(ix), a
   	ret

	
generator_sys_update_enemigos::
	call entity_man_getEnemyArray_IX
	call entity_man_getFreeSpace_A
	sub #0
	ret	 z
	call generator_sys_Enemigos
	ret

generator_sys_Enemigos:
	generate_en:
    call cpct_getRandom_xsp40_u8_asm
	ld bc, (barrera_1_value)
    and c
    sub c
    jr z, barrera_1
    ret

    barrera_1:
        call cpct_getRandom_xsp40_u8_asm
        ld bc, (barrera_2_value)
		and c
        sub c
        jr z, barrera_2
        ret
	barrera_2:	
		call cpct_getRandom_xsp40_u8_asm
        ld bc, (barrera_3_value)
		and c
        sub c
        jr z, genera_enemigo
        ret


    genera_enemigo:
		call get_current_level_A
		sub #4
		jp z, oleadas_nv4

		call get_current_level_A
		sub #3
		jp z, oleadas_nv3

		call get_current_level_A
		sub #2
		jp z, oleadas_nv2

		call get_current_level_A
		sub #1
		jp z, oleadas_nv1

		oleadas_nv1:
			call reset_recuento_oleadas_nv4
			ld a, (recuento_oleadas_nv1)
			cp #1
			call z, tirar_oleada_9
			cp #2
			call z, tirar_oleada_2
			cp #3
			call z, tirar_oleada_10
			cp #4
			call z, tirar_oleada_4
			cp #5
			call z, tirar_oleada_3
			cp #6
			call z, tirar_oleada_2
			cp #7
			call z, tirar_oleada_10
			cp #8
			call z, tirar_oleada_7
			cp #9
			call z, tirar_oleada_7
			cp #10
			call z, tirar_oleada_2
			cp #11
			call z, tirar_oleada_7
			cp #12
			call z, tirar_oleada_9
			cp #13
			call z, tirar_oleada_9
			cp #14
			call z, tirar_oleada_10
			cp #15
			call z, tirar_oleada_10
			

			ld a, (recuento_oleadas_nv1)
			dec a
			ld (recuento_oleadas_nv1), a
			ret
		oleadas_nv2:
			
			call reset_recuento_oleadas_nv1

			ld a, (recuento_oleadas_nv2)
			cp #1
			call z, tirar_oleada_6
			cp #2
			call z, tirar_oleada_2
			cp #3
			call z, tirar_oleada_7
			cp #4
			call z, tirar_oleada_2
			cp #5
			call z, tirar_oleada_10
			cp #6
			call z, tirar_oleada_3
			cp #7
			call z, tirar_oleada_2
			cp #8
			call z, tirar_oleada_7
			cp #9
			call z, tirar_oleada_2
			cp #10
			call z, tirar_oleada_10
			cp #11
			call z, tirar_oleada_3
			cp #12
			call z, tirar_oleada_9
			cp #13
			call z, tirar_oleada_2
			cp #14
			call z, tirar_oleada_7
			cp #15
			call z, tirar_oleada_8
			

			ld a, (recuento_oleadas_nv2)
			dec a
			ld (recuento_oleadas_nv2), a
			ret


		oleadas_nv3:
			call reset_recuento_oleadas_nv2

			ld a, (recuento_oleadas_nv3)
			cp #1
			call z, tirar_oleada_7
			cp #2
			call z, tirar_oleada_7
			cp #3
			call z, tirar_oleada_7
			cp #4
			call z, tirar_oleada_1
			cp #5
			call z, tirar_oleada_9
			cp #6
			call z, tirar_oleada_7
			cp #7
			call z, tirar_oleada_2
			cp #8
			call z, tirar_oleada_7
			cp #9
			call z, tirar_oleada_8
			cp #10
			call z, tirar_oleada_1
			cp #11
			call z, tirar_oleada_9
			cp #12
			call z, tirar_oleada_7
			cp #13
			call z, tirar_oleada_8
			cp #14
			call z, tirar_oleada_1
			cp #15
			call z, tirar_oleada_9
			cp #16
			call z, tirar_oleada_8
			cp #17
			call z, tirar_oleada_1
			cp #18
			call z, tirar_oleada_9
			cp #19
			call z, tirar_oleada_7
			cp #20
			call z, tirar_oleada_8
			cp #21
			call z, tirar_oleada_1
			cp #22
			call z, tirar_oleada_9

			ld a, (recuento_oleadas_nv3)
			dec a
			ld (recuento_oleadas_nv3), a
			ret
	
		oleadas_nv4:
			call reset_recuento_oleadas_nv3

			ld a, (recuento_oleadas_nv4)
			cp #1
			call z, tirar_oleada_2
			cp #2
			call z, tirar_oleada_4
			cp #3
			call z, tirar_oleada_3
			cp #4
			call z, tirar_oleada_6
			cp #5
			call z, tirar_oleada_3
			cp #6
			call z, tirar_oleada_2
			cp #7
			call z, tirar_oleada_6
			cp #8
			call z, tirar_oleada_5
			cp #9
			call z, tirar_oleada_10
			cp #10
			call z, tirar_oleada_9
			cp #11
			call z, tirar_oleada_3
			cp #12
			call z, tirar_oleada_3
			cp #13
			call z, tirar_oleada_5
			cp #14
			call z, tirar_oleada_2
			cp #15
			call z, tirar_oleada_6
			cp #6
			call z, tirar_oleada_2
			cp #17
			call z, tirar_oleada_7
			cp #18
			call z, tirar_oleada_3
			cp #19
			call z, tirar_oleada_6
			cp #20
			call z, tirar_oleada_3
			cp #21
			call z, tirar_oleada_2
			cp #22
			call z, tirar_oleada_6
			cp #23
			call z, tirar_oleada_5
			cp #24
			call z, tirar_oleada_10
			cp #25
			call z, tirar_oleada_4
			cp #26
			call z, tirar_oleada_3
			cp #27
			call z, tirar_oleada_3
			cp #28
			call z, tirar_oleada_5
			cp #29
			call z, tirar_oleada_2
			cp #30
			call z, tirar_oleada_6
			
		
			ld a, (recuento_oleadas_nv4)
			dec a
			ld (recuento_oleadas_nv4), a
			
			ret
	

		

		

		

		


