;;
;; RENEDER DEL SYSTEMA 
;;
.include "cpctelera.h.s"
.include "man/entity_manager.h.s"
.include "render_system.h.s"
.include "../cpct_functions.h.s"

DefineSprit _vida1, _tierra_mini_sp, 23, 180, 16, 8
DefineSprit _vida2, _tierra_mini_sp, 32, 180, 16, 8
DefineSprit _vida3, _tierra_mini_sp, 41, 180, 16, 8
DefineSprit _tierra, _tierra_sp, 0, 0, 174, 5
DefineSprit _vidas, _vida_sp, 5, 180, 16, 16

background = 0x00

;--------------------------------------------------------------
;	FUNCIONES 
;--------------------------------------------------------------

; Funcion para inializar el reder de la pantalla 
render_sys_init::

    call cpct_disableFirmware_asm
    
    ld      c, #0 ;;ESTABA A 0
    call cpct_setVideoMode_asm
    ld hl, #_nave_pal
    ld de, #16
    call cpct_setPalette_asm
	cpctm_setBorder_asm HW_BLACK
	ret


; Funcion que nos sirve para renderizar una entidad
;   IMPUT
;       IX: Tiene que estar la  direccion de la entidad
render_sys_update_one::

    ld       a, e_prevY(ix)
    add      e_prevX(ix)
    jr       z, continuar

    Clean e_prevX(ix), e_prevY(ix), e_h(ix), e_w(ix)

    continuar:
        ld      a,  e_state(ix)         ; \
        and     #entity_dead            ; | Si la entidad esta marcada para eliminar no la pinta
        ret      nz                     ; /

    print_valid:
        ld   	 de, #0xC000  			; \
        ld    	 b, e_y(ix)				; |	
        ld    	 c, e_x(ix)				; | Calculamos la posicion en pantalla
        call cpct_getScreenPtr_asm    	; /

        ex de, hl
        ld l, e_sprite_l(ix)
        ld h, e_sprite_h(ix)
        ld b, e_h(ix) ;alto
        ld c, e_w(ix) ;ancho  

        call cpct_drawSprite_asm

        ld      d, e_x(ix)              ; \
        ld      e_prevX(ix), d          ; | Guardamos la posicione anteriore de la entidad 
        ld      d, e_y(ix)              ; |
        ld      e_prevY(ix), d          ; /

        ret



;; Funcion para que se redericen las estrellas
render_sys_update::

    ld      hl, #render_sys_update_one  
    call    entity_man_getStarsArray_IX
    call    entity_man_forAll
    ret
	
;; Funcion para que se renderice la nave 
render_sys_update_Nave::

    ld      hl, #render_sys_update_one  
    call    entity_man_getNaveArray_IX
    call    entity_man_forAll
    ret

;; Funcion para que se renderice el enemigo
render_sys_update_Enemigo::

    ld      hl, #render_sys_update_one  
    call    entity_man_getEnemyArray_IX
    call    entity_man_forAll
    ret

render_Draw:
    call Draw_vida1
    call Draw_vida2
    call Draw_vida3
    call Draw_tierra
    call Draw_vidas
    ret

render_lose_live1:
    Clean   #41, #180, #16, #8
    ret

render_lose_live2:
    Clean   #32, #180, #16, #8
    ret